from PyQt5.QtWidgets import QDialog, QVBoxLayout, QLabel, QLineEdit, QPushButton, QMessageBox
from .license_manager import LicenseManager

class LicenseInputDialog(QDialog):
    def __init__(self, config_file, parent=None):
        super().__init__(parent)
        self.setWindowTitle("認証「chibansearch」")
        self.setModal(True)
        self.config_file = config_file  # コンフィグファイルを保存

        layout = QVBoxLayout()

        self.label = QLabel("ライセンスキーを入力してください:")
        layout.addWidget(self.label)

        self.lineEdit = QLineEdit()
        layout.addWidget(self.lineEdit)

        self.submitButton = QPushButton("実行")
        self.submitButton.clicked.connect(self.validate_license)
        layout.addWidget(self.submitButton)

        self.setLayout(layout)

    def validate_license(self):
        license_key = self.lineEdit.text().strip()

        # ライセンスマネージャーの初期化
        license_manager = LicenseManager(self.config_file)

        # ライセンスの検証
        if license_manager.validate_license(license_key) and license_manager.check_expiry():
            self.accept()  # ライセンスが有効ならダイアログを閉じる
        else:
            QMessageBox.warning(self, "無効なライセンス", "ライセンスキーが無効または期限切れです。もう一度試してください。")
